"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_native_svg_uri_1 = __importDefault(require("../../lib/react-native-svg-uri"));
const svg_1 = __importDefault(require("../../assets/svg"));
const Touchable_1 = __importDefault(require("../Touchable"));
const Icon = props => {
    const { name, color = '#666', size = 20, style = {}, onPress } = props;
    let svgXmlData = svg_1.default[name];
    if (!svgXmlData) {
        throw new Error(`No Icon Named ${name} Was Found!`);
    }
    return (react_1.default.createElement(Touchable_1.default, { onPress: onPress, style: style },
        react_1.default.createElement(react_native_svg_uri_1.default, { width: size, height: size, svgXmlData: svgXmlData, fill: color })));
};
exports.default = Icon;
