"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.portal = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const addEventKey = 'REACT_NATIVE_UI_VIEW_ADD_PORTAL';
const removeEventKey = 'REACT_NATIVE_UI_VIEW_REMOVE_PORTAL';
const eventEmitter = react_native_1.DeviceEventEmitter;
class PortalGuard {
    constructor() {
        this.key = 100;
    }
    add(elem) {
        const key = this.key++;
        eventEmitter.emit(addEventKey, { elem, key });
        return key;
    }
    remove(key) {
        eventEmitter.emit(removeEventKey, key);
    }
}
const PortalHost = () => {
    const [portalList, setPortalList] = react_1.useState([]);
    react_1.useEffect(() => {
        const listenerAdd = eventEmitter.addListener(addEventKey, mount);
        const listenerRemove = eventEmitter.addListener(removeEventKey, unmount);
        return () => {
            listenerAdd.remove();
            listenerRemove.remove();
        };
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    const mount = (portalItem) => {
        setPortalList([...portalList, portalItem]);
    };
    const unmount = (key) => {
        setPortalList([...portalList].filter(item => item.key !== key));
    };
    return (react_1.default.createElement(react_1.default.Fragment, null, portalList.map(item => (react_1.default.createElement(react_native_1.View, { style: styles.portal, key: item.key, pointerEvents: "box-none" }, item.elem)))));
};
exports.portal = new PortalGuard();
class Portal extends react_1.default.Component {
    render() {
        return (react_1.default.createElement(react_1.default.Fragment, null,
            this.props.children,
            react_1.default.createElement(PortalHost, null)));
    }
}
exports.default = Portal;
Portal.add = exports.portal.add;
Portal.remove = exports.portal.remove;
const styles = react_native_1.StyleSheet.create({
    portal: {
        position: 'absolute',
        left: 0,
        top: 0,
        right: 0,
        bottom: 0,
    },
});
