import React from 'react';
import { TouchableHighlight } from 'react-native';
import { Theme } from '../Styles/theme';
const Touchable = props => {
    const { style, onPress, disabled = false, children, underlayColor = Theme.fillTap, activeOpacity = 0.6, hitSlop = 10, } = props;
    let slop = {};
    if (typeof hitSlop === 'number') {
        slop = {
            top: hitSlop,
            right: hitSlop,
            bottom: hitSlop,
            left: hitSlop,
        };
    }
    else {
        slop = hitSlop;
    }
    return (React.createElement(TouchableHighlight, { disabled: disabled, underlayColor: underlayColor, activeOpacity: activeOpacity, onPress: onPress, style: style, hitSlop: slop }, children));
};
export default Touchable;
